;**********************************************************************
;
;  v`R4pPC8001G~[^IMGt@C
;  PC8001-mini œǂݍނ߂̃[_
;
;  (2020.06.29)
;
;  CMTt@CɂA imgt@CB
;  PCGf[^̗ĹAPCGf[^œǂݍ݂^CAEgA
;  PCGf[^͂Ȃ̂Ƃ݂ȂB
;
;  Ⴆ΁A
;  copy /b img_loader.cmt + C[Wt@C.img CMTt@C.cmt
;
;
;  img_loader.cmt ̖ɂ́A$F5, $F6, $F7̃}[J[O
;  ǉĂ܂B
;
;**********************************************************************

  ORG  06000H

  CALL 0BF3H             ; Motor ON and ready for input

SEARCH_MARKER:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F5H
  JR   Z,FOUND_F5
  JR   SEARCH_MARKER
FOUND_F5:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F6H
  JR   Z,FOUND_F6
  CMP  F5h
  JR   Z,FOUND_F5
  JR   SEARCH MARKER
FOUND_F6:
  CALL 0C88H             ; Read 1byte from CMT and throw away
  CMP  F7H
  JR   Z,FOUND_F7
  CMP  F5h
  JR   Z,FOUND_F5
  JR   SEARCH MARKER
FOUND_F7:


  LD   SP,8000H          ; Change Stack pointer
  LD   BC,8000H          ; number of bytes to be read from CMT
  LD   HL,8000H          ; Start address of image

LOOP_C:
  CALL 0C88H             ; Read 1 bytes
  LD   (HL),A            ; Store read byte
  INC  HL                ; update address
  DEC  BC                ; decrement counter
  LD   A,B               ; Check counter reaches zero
  OR   C
  JR   NZ,LOOP_C         ; If not finish, repeat

  LD   B,4               ; number of words to be read
OMOTE:
  CALL LONG2_HL          ; Load register values of AF,BC,DE,HL
  PUSH HL                ; And pushed them for later use
  DJNZ OMOTE

  CALL LONG_HL           ; Load PC value
  LD   (JUMP_ENTRY+1),HL ; Store PC value to LD operand

  CALL LONG_HL           ; Load SP value
  LD   (SP_ENTRY+1),HL   ; Store SP value to LD operand

  CALL LONG_HL           ; Load IX value and push
  PUSH,HL

  CALL LONG_HL           ; Load IY value and push
  PUSH,HL

  LD   B,4               ; number of words to be read
URA:
  CALL LONG2_HL          ; Load register values of AF',BC',DE',HL'
  PUSH HL                ; And pushed thrm for later use
  DJNZ URA

  ;
  ; READ PCG part
  ;
  CALL SET_PCG

  ;
  ; Restore screen mode
  ;
  LD   A,(0EA60H)        ; Color and console
  LD   B,A
  LD   A,(0EA61H)
  LD   C,A
  CALL 08F7H

  LD   A,(0EA62H)        ; Width setting
  LD   C,A
  LD   A,(0EA65H)
  LD   B,A
  CALL 093AH

  ;
  ;  Restore Register values from stack
  ;
  POP  HL
  POP  DE
  POP  BC
  EXX
  POP  AF
  EX   AF,AF'
  POP  IY
  POP  IX
  POP  HL
  POP  DE
  POP  BC
  POP  AF


SP_ENTRY:
  ;
  ; Restore SP register
  ;
  LD   SP,0


JUMP_ENTRY:
  ;
  ; Jump to resume PC address
  ;
  JP   0


;********************************
; READ 2 bytes from 2 long data
;********************************
LONG2_HL:
  CALL 0C88H             ; Read 1 bytes (Low byte)
  LD   H,A
  CALL 0C88H             ; Read 1 bytes and throw away
  CALL 0C88H             ; Read 1 bytes and throw away
  CALL 0C88H             ; Read 1 bytes and throw away

  CALL 0C88H             ; Read 1 bytes (Hig byte)
  LD   L,A
  CALL 0C88H             ; Read 1 bytes and throw away
  CALL 0C88H             ; Read 1 bytes and throw away
  CALL 0C88H             ; Read 1 bytes and throw away
  RET

;********************************
; READ 2 byts from 1 long data
;********************************
LONG_HL:
  CALL 0C88H             ; Read 1 bytes (Low byte)
  LD   L,A
  CALL 0C88H             ; Read 1 bytes (Hig byte)
  LD   H,A
  CALL 0C88H             ; Read 1 bytes and throw away
  CALL 0C88H             ; Read 1 bytes and throw away
  RET

;********************************
; PCG setup
;********************************
SET_PCG:
  LD   HL, 0             ; PCG address initialize
  LD   BC, 1024          ; byte counter

PCG_LOOP:
  CALL CCRIN2            ; Read 1byte from CMT
  RET  C
  OUT  (00H),A           ; Write data
  LD   A,L               ; Write Lower address
  OUT  (01H),A
  LD   A,H               ; Higher address(2bit) + write flag
  OR   10H
  OUT  (02H),A
  LD   A,H               ; Higher address(2bit)
  OUT  (02H),A
  INC  HL                ; update address
  DEC  BC                ; decrement counter
  LD   A,B               ; check counter
  OR   C
  JR   NZ, PCG_LOOP      ; If counter is not zero, repeat
  RET                    ; return

;*************************************
; CMT read with timeout
;
; Return
;    A-reg RETURN byte
;    flag: NC no error
;          C  error or time out
;*************************************
CCRIN2:
  PUSH BC
  LD   BC,512           ; Timeout count

CCRIN2_WAIT:            ; wait for ready
  IN   A,(21h)
  AND  2
  JR   NZ,CCRIN2_READY  ; if ready, jump to CCRIN2_READY
  DEC  BC               ; decriment counter
  LD   A,B
  OR   C
  JR   NZ,CCRIN2_WAIT   ; if counter still remains, retry
  ;
  ; return due to Time out
  ;
  POP  BC
  SCF                   ; Set C flag
  RET

CCRIN2_READY:
  ;
  ; Read 1 byte from CMT with error check
  ;
  IN   A,(21h)           ; Error check
  CPL
  AND  30H
  CP   30H               ; C flag if error
  IN   A,(20H)           ; read data from PD8251
  POP  BC
  RET
